/****************************************************************************************************
	6/96 bob	Updated #includes to support changed GX Library names.
	
	1990 - 1996  Apple Computer, Inc.
	All rights reserved.
****************************************************************************************************/
#include <Types.h>
#include <QuickDraw.h>
#include <Fonts.h>
#include <Windows.h>
#include <Menus.h>
#include <SegLoad.h>
#include <Memory.h>
#include <Desk.h>

#include <GXGraphics.h>
#include "GraphicsLibraries.h"
#include <GXEnvironment.h>

#include <GXTypes.h>
#include "LayoutFeatureConstants.h"
#include <GXLayout.h>
#include "LayoutLibrary.h"

#include "SampleInterface.h"

short MyStrLen(char *x);
static short MyStrLen(x)
char	*x;
	{
	short c = 0;
	while (*x++) c++;
	return c;
	}	/* MyStrLen */

void CaseSubstitution(WindowPtr sampleWindow)
	{
	/* Variables */
	char			*myString = "abCDe";
	gxPoint			myPoint;
	gxRunControls		myControls;
	gxRunFeature		gxRunFeature;
	gxShape			layout;
	short			len, level = 0;
	gxStyle			myStyle;
	gxViewPort		aViewPort;
	
	/* Initialization */
	
	myPoint.x = ff(20);
	myPoint.y = ff(50);
	
	aViewPort = GXNewWindowViewPort(sampleWindow);
	SetDefaultViewPort(aViewPort);
	
	len = MyStrLen(myString);
	
	InitializeRunControls(&myControls);
	myControls.flags = gxNoOpticalAlignment;
	
	myStyle = NewLayoutStyle((char *) "\pHoefler Text", ff(50), 0, &myControls, nil, 0, nil);
	
	layout = GXNewLayout(
		1, &len, (void *) &myString,
		1, &len, &myStyle,
		1, &len, &level,
		nil, &myPoint);
	GXDrawShape(layout);
	
	gxRunFeature.featureType = letterNumberCaseType;
	gxRunFeature.featureSelector = letterNumberCaseAllUpperSelector;
	GXSetStyleRunFeatures(myStyle, 1, &gxRunFeature);
	GXMoveShape(layout, 0, ff(75));
	GXDrawShape(layout);
	
	gxRunFeature.featureSelector = letterNumberCaseAllLowerSelector;
	GXSetStyleRunFeatures(myStyle, 1, &gxRunFeature);
	GXMoveShape(layout, 0, ff(75));
	GXDrawShape(layout);
	
	gxRunFeature.featureSelector = letterNumberCaseSmallCapsSelector;
	GXSetStyleRunFeatures(myStyle, 1, &gxRunFeature);
	GXMoveShape(layout, 0, ff(75));
	GXDrawShape(layout);
	
	GXDisposeShape(layout);
	GXDisposeStyle(myStyle);
	GXDisposeViewPort(aViewPort);
	}	/* main */
